/* test-class-signal-performance.c generated by valac 0.28.0, the Vala compiler
 * generated from test-class-signal-performance.vala, do not modify */

/*
 * Copyright (C) 2008, Nokia <ivan.frade@nokia.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "libtracker-sparql/tracker-sparql.h"
#include <gobject/gvaluecollector.h>


#define TYPE_EVENT (event_get_type ())
typedef struct _Event Event;

#define TYPE_RESOURCES (resources_get_type ())
#define RESOURCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RESOURCES, Resources))
#define IS_RESOURCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RESOURCES))
#define RESOURCES_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_RESOURCES, ResourcesIface))

typedef struct _Resources Resources;
typedef struct _ResourcesIface ResourcesIface;

#define TYPE_RESOURCES_PROXY (resources_proxy_get_type ())
typedef GDBusProxy ResourcesProxy;
typedef GDBusProxyClass ResourcesProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_RESOURCESCLASS (resourcesclass_get_type ())
#define RESOURCESCLASS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RESOURCESCLASS, ResourcesClass))
#define IS_RESOURCESCLASS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RESOURCESCLASS))
#define RESOURCESCLASS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_RESOURCESCLASS, ResourcesClassIface))

typedef struct _ResourcesClass ResourcesClass;
typedef struct _ResourcesClassIface ResourcesClassIface;

#define TYPE_RESOURCESCLASS_PROXY (resourcesclass_proxy_get_type ())
typedef GDBusProxy ResourcesClassProxy;
typedef GDBusProxyClass ResourcesClassProxyClass;

#define TYPE_TEST_APP (test_app_get_type ())
#define TEST_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEST_APP, TestApp))
#define TEST_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEST_APP, TestAppClass))
#define IS_TEST_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEST_APP))
#define IS_TEST_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEST_APP))
#define TEST_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEST_APP, TestAppClass))

typedef struct _TestApp TestApp;
typedef struct _TestAppClass TestAppClass;
typedef struct _TestAppPrivate TestAppPrivate;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecTestApp ParamSpecTestApp;
#define _test_app_unref0(var) ((var == NULL) ? NULL : (var = (test_app_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Event {
	gint graph_id;
	gint subject_id;
	gint pred_id;
	gint object_id;
};

struct _ResourcesIface {
	GTypeInterface parent_iface;
	void (*sparql_update_async) (Resources* self, const gchar* query, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*sparql_update_finish) (Resources* self, GAsyncResult* _res_, GError** error);
};

struct _ResourcesClassIface {
	GTypeInterface parent_iface;
};

struct _TestApp {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TestAppPrivate * priv;
};

struct _TestAppClass {
	GTypeClass parent_class;
	void (*finalize) (TestApp *self);
};

struct _TestAppPrivate {
	GMainLoop* loop;
	gboolean initialized;
	TrackerSparqlConnection* con;
	gint count;
	GTimer* t;
};

struct _ParamSpecTestApp {
	GParamSpec parent_instance;
};


static gpointer test_app_parent_class = NULL;
static Resources* test_app_resources_object;
static Resources* test_app_resources_object = NULL;
static ResourcesClass* test_app_class_object;
static ResourcesClass* test_app_class_object = NULL;

#define max_signals 1000
#define title_data "title"
GType event_get_type (void) G_GNUC_CONST;
Event* event_dup (const Event* self);
void event_free (Event* self);
GType resources_proxy_get_type (void) G_GNUC_CONST;
guint resources_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType resources_get_type (void) G_GNUC_CONST;
void resources_sparql_update_async (Resources* self, const gchar* query, GAsyncReadyCallback _callback_, gpointer _user_data_);
void resources_sparql_update_finish (Resources* self, GAsyncResult* _res_, GError** error);
static void g_cclosure_user_marshal_VOID__STRING_POINTER_INT_POINTER_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void resources_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_resources_graph_updated (Resources* self, GVariant* parameters);
static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data);
static void resources_proxy_sparql_update_async_async (Resources* self, const gchar* query, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void resources_proxy_sparql_update_async_finish (Resources* self, GAsyncResult* _res_, GError** error);
static void resources_proxy_resources_interface_init (ResourcesIface* iface);
static void _dbus_resources_sparql_update_async (Resources* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_resources_sparql_update_async_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void resources_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* resources_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean resources_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_resources_graph_updated (GObject* _sender, const gchar* class_name, Event* deletes, int deletes_length1, Event* inserts, int inserts_length1, gpointer* _data);
static void _resources_unregister_object (gpointer user_data);
GType resourcesclass_get_type (void) G_GNUC_CONST;
GType resourcesclass_proxy_get_type (void) G_GNUC_CONST;
guint resourcesclass_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
static void g_cclosure_user_marshal_VOID__BOXED_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__BOXED_INT_BOXED_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void resourcesclass_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_resourcesclass_subjects_added (ResourcesClass* self, GVariant* parameters);
static void _dbus_handle_resourcesclass_subjects_changed (ResourcesClass* self, GVariant* parameters);
static void resourcesclass_proxy_resourcesclass_interface_init (ResourcesClassIface* iface);
static void resourcesclass_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* resourcesclass_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean resourcesclass_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_resourcesclass_subjects_added (GObject* _sender, gchar** subjects, int subjects_length1, gpointer* _data);
static void _dbus_resourcesclass_subjects_changed (GObject* _sender, gchar** subjects, int subjects_length1, gchar** preds, int preds_length1, gpointer* _data);
static void _resourcesclass_unregister_object (gpointer user_data);
gpointer test_app_ref (gpointer instance);
void test_app_unref (gpointer instance);
GParamSpec* param_spec_test_app (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_test_app (GValue* value, gpointer v_object);
void value_take_test_app (GValue* value, gpointer v_object);
gpointer value_get_test_app (const GValue* value);
GType test_app_get_type (void) G_GNUC_CONST;
#define TEST_APP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TEST_APP, TestAppPrivate))
enum  {
	TEST_APP_DUMMY_PROPERTY
};
TestApp* test_app_new (void);
TestApp* test_app_construct (GType object_type);
static void test_app_on_subjects_added (TestApp* self, gchar** subjects, int subjects_length1);
static void _test_app_on_subjects_added_resourcesclass_subjects_added (ResourcesClass* _sender, gchar** subjects, int subjects_length1, gpointer self);
static void test_app_on_subjects_changed (TestApp* self, gchar** subjects, int subjects_length1, gchar** preds, int preds_length1);
static void _test_app_on_subjects_changed_resourcesclass_subjects_changed (ResourcesClass* _sender, gchar** subjects, int subjects_length1, gchar** preds, int preds_length1, gpointer self);
static void test_app_on_graph_updated_received (TestApp* self, const gchar* class_name, Event* deletes, int deletes_length1, Event* inserts, int inserts_length1);
static void _test_app_on_graph_updated_received_resources_graph_updated (Resources* _sender, const gchar* class_name, Event* deletes, int deletes_length1, Event* inserts, int inserts_length1, gpointer self);
static void test_app_insert_data (TestApp* self);
static gboolean test_app_in_mainloop (TestApp* self);
gint test_app_run (TestApp* self);
static gboolean _test_app_in_mainloop_gsource_func (gpointer self);
static void test_app_finalize (TestApp* obj);
gint _vala_main (gchar** args, int args_length1);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusArgInfo _resources_dbus_arg_info_sparql_update_async_query = {-1, "query", "s"};
static const GDBusArgInfo * const _resources_dbus_arg_info_sparql_update_async_in[] = {&_resources_dbus_arg_info_sparql_update_async_query, NULL};
static const GDBusArgInfo * const _resources_dbus_arg_info_sparql_update_async_out[] = {NULL};
static const GDBusMethodInfo _resources_dbus_method_info_sparql_update_async = {-1, "SparqlUpdate", (GDBusArgInfo **) (&_resources_dbus_arg_info_sparql_update_async_in), (GDBusArgInfo **) (&_resources_dbus_arg_info_sparql_update_async_out)};
static const GDBusMethodInfo * const _resources_dbus_method_info[] = {&_resources_dbus_method_info_sparql_update_async, NULL};
static const GDBusArgInfo _resources_dbus_arg_info_graph_updated_class_name = {-1, "class_name", "s"};
static const GDBusArgInfo _resources_dbus_arg_info_graph_updated_deletes = {-1, "deletes", "a(iiii)"};
static const GDBusArgInfo _resources_dbus_arg_info_graph_updated_inserts = {-1, "inserts", "a(iiii)"};
static const GDBusArgInfo * const _resources_dbus_arg_info_graph_updated[] = {&_resources_dbus_arg_info_graph_updated_class_name, &_resources_dbus_arg_info_graph_updated_deletes, &_resources_dbus_arg_info_graph_updated_inserts, NULL};
static const GDBusSignalInfo _resources_dbus_signal_info_graph_updated = {-1, "GraphUpdated", (GDBusArgInfo **) (&_resources_dbus_arg_info_graph_updated)};
static const GDBusSignalInfo * const _resources_dbus_signal_info[] = {&_resources_dbus_signal_info_graph_updated, NULL};
static const GDBusPropertyInfo * const _resources_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _resources_dbus_interface_info = {-1, "org.freedesktop.Tracker1.Resources", (GDBusMethodInfo **) (&_resources_dbus_method_info), (GDBusSignalInfo **) (&_resources_dbus_signal_info), (GDBusPropertyInfo **) (&_resources_dbus_property_info)};
static const GDBusInterfaceVTable _resources_dbus_interface_vtable = {resources_dbus_interface_method_call, resources_dbus_interface_get_property, resources_dbus_interface_set_property};
static const GDBusMethodInfo * const _resourcesclass_dbus_method_info[] = {NULL};
static const GDBusArgInfo _resourcesclass_dbus_arg_info_subjects_added_subjects = {-1, "subjects", "as"};
static const GDBusArgInfo * const _resourcesclass_dbus_arg_info_subjects_added[] = {&_resourcesclass_dbus_arg_info_subjects_added_subjects, NULL};
static const GDBusSignalInfo _resourcesclass_dbus_signal_info_subjects_added = {-1, "SubjectsAdded", (GDBusArgInfo **) (&_resourcesclass_dbus_arg_info_subjects_added)};
static const GDBusArgInfo _resourcesclass_dbus_arg_info_subjects_changed_subjects = {-1, "subjects", "as"};
static const GDBusArgInfo _resourcesclass_dbus_arg_info_subjects_changed_preds = {-1, "preds", "as"};
static const GDBusArgInfo * const _resourcesclass_dbus_arg_info_subjects_changed[] = {&_resourcesclass_dbus_arg_info_subjects_changed_subjects, &_resourcesclass_dbus_arg_info_subjects_changed_preds, NULL};
static const GDBusSignalInfo _resourcesclass_dbus_signal_info_subjects_changed = {-1, "SubjectsChanged", (GDBusArgInfo **) (&_resourcesclass_dbus_arg_info_subjects_changed)};
static const GDBusSignalInfo * const _resourcesclass_dbus_signal_info[] = {&_resourcesclass_dbus_signal_info_subjects_added, &_resourcesclass_dbus_signal_info_subjects_changed, NULL};
static const GDBusPropertyInfo * const _resourcesclass_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _resourcesclass_dbus_interface_info = {-1, "org.freedesktop.Tracker1.Resources.Class", (GDBusMethodInfo **) (&_resourcesclass_dbus_method_info), (GDBusSignalInfo **) (&_resourcesclass_dbus_signal_info), (GDBusPropertyInfo **) (&_resourcesclass_dbus_property_info)};
static const GDBusInterfaceVTable _resourcesclass_dbus_interface_vtable = {resourcesclass_dbus_interface_method_call, resourcesclass_dbus_interface_get_property, resourcesclass_dbus_interface_set_property};

Event* event_dup (const Event* self) {
	Event* dup;
#line 47 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	dup = g_new0 (Event, 1);
#line 47 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	memcpy (dup, self, sizeof (Event));
#line 47 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return dup;
#line 231 "test-class-signal-performance.c"
}


void event_free (Event* self) {
#line 47 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_free (self);
#line 238 "test-class-signal-performance.c"
}


GType event_get_type (void) {
	static volatile gsize event_type_id__volatile = 0;
	if (g_once_init_enter (&event_type_id__volatile)) {
		GType event_type_id;
		event_type_id = g_boxed_type_register_static ("Event", (GBoxedCopyFunc) event_dup, (GBoxedFreeFunc) event_free);
		g_once_init_leave (&event_type_id__volatile, event_type_id);
	}
	return event_type_id__volatile;
}


void resources_sparql_update_async (Resources* self, const gchar* query, GAsyncReadyCallback _callback_, gpointer _user_data_) {
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	RESOURCES_GET_INTERFACE (self)->sparql_update_async (self, query, _callback_, _user_data_);
#line 256 "test-class-signal-performance.c"
}


void resources_sparql_update_finish (Resources* self, GAsyncResult* _res_, GError** error) {
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	RESOURCES_GET_INTERFACE (self)->sparql_update_finish (self, _res_, error);
#line 263 "test-class-signal-performance.c"
}


static void g_cclosure_user_marshal_VOID__STRING_POINTER_INT_POINTER_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_POINTER_INT_POINTER_INT) (gpointer data1, const char* arg_1, gpointer arg_2, gint arg_3, gpointer arg_4, gint arg_5, gpointer data2);
	register GMarshalFunc_VOID__STRING_POINTER_INT_POINTER_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_if_fail (n_param_values == 6);
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		data1 = closure->data;
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		data2 = param_values->data[0].v_pointer;
#line 282 "test-class-signal-performance.c"
	} else {
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		data1 = param_values->data[0].v_pointer;
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		data2 = closure->data;
#line 288 "test-class-signal-performance.c"
	}
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	callback = (GMarshalFunc_VOID__STRING_POINTER_INT_POINTER_INT) (marshal_data ? marshal_data : cc->callback);
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_pointer (param_values + 2), g_value_get_int (param_values + 3), g_value_get_pointer (param_values + 4), g_value_get_int (param_values + 5), data2);
#line 294 "test-class-signal-performance.c"
}


static void resources_base_init (ResourcesIface * iface) {
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	static gboolean initialized = FALSE;
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (!initialized) {
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		initialized = TRUE;
#line 55 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_signal_new ("graph_updated", TYPE_RESOURCES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_POINTER_INT_POINTER_INT, G_TYPE_NONE, 5, G_TYPE_STRING, G_TYPE_POINTER, G_TYPE_INT, G_TYPE_POINTER, G_TYPE_INT);
#line 307 "test-class-signal-performance.c"
	}
}


GType resources_get_type (void) {
	static volatile gsize resources_type_id__volatile = 0;
	if (g_once_init_enter (&resources_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ResourcesIface), (GBaseInitFunc) resources_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType resources_type_id;
		resources_type_id = g_type_register_static (G_TYPE_INTERFACE, "Resources", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (resources_type_id, G_TYPE_DBUS_PROXY);
		g_type_set_qdata (resources_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) resources_proxy_get_type);
		g_type_set_qdata (resources_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.Tracker1.Resources");
		g_type_set_qdata (resources_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_resources_dbus_interface_info));
		g_type_set_qdata (resources_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) resources_register_object);
		g_once_init_leave (&resources_type_id__volatile, resources_type_id);
	}
	return resources_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (ResourcesProxy, resources_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_RESOURCES, resources_proxy_resources_interface_init) )
static void resources_proxy_class_init (ResourcesProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = resources_proxy_g_signal;
}


static void _dbus_handle_resources_graph_updated (Resources* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	gchar* class_name = NULL;
	GVariant* _tmp0_;
	Event* deletes = NULL;
	int deletes_length1;
	GVariant* _tmp1_;
	Event* _tmp2_;
	int _tmp2__length;
	int _tmp2__size;
	int _tmp2__length1;
	GVariantIter _tmp3_;
	GVariant* _tmp4_;
	Event* inserts = NULL;
	int inserts_length1;
	GVariant* _tmp11_;
	Event* _tmp12_;
	int _tmp12__length;
	int _tmp12__size;
	int _tmp12__length1;
	GVariantIter _tmp13_;
	GVariant* _tmp14_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	class_name = g_variant_dup_string (_tmp0_, NULL);
	g_variant_unref (_tmp0_);
	deletes_length1 = 0;
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp2_ = g_new (Event, 5);
	_tmp2__length = 0;
	_tmp2__size = 4;
	_tmp2__length1 = 0;
	g_variant_iter_init (&_tmp3_, _tmp1_);
	for (; (_tmp4_ = g_variant_iter_next_value (&_tmp3_)) != NULL; _tmp2__length1++) {
		Event _tmp5_;
		GVariantIter _tmp6_;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
		GVariant* _tmp9_;
		GVariant* _tmp10_;
		if (_tmp2__size == _tmp2__length) {
			_tmp2__size = 2 * _tmp2__size;
			_tmp2_ = g_renew (Event, _tmp2_, _tmp2__size + 1);
		}
		g_variant_iter_init (&_tmp6_, _tmp4_);
		_tmp7_ = g_variant_iter_next_value (&_tmp6_);
		_tmp5_.graph_id = g_variant_get_int32 (_tmp7_);
		g_variant_unref (_tmp7_);
		_tmp8_ = g_variant_iter_next_value (&_tmp6_);
		_tmp5_.subject_id = g_variant_get_int32 (_tmp8_);
		g_variant_unref (_tmp8_);
		_tmp9_ = g_variant_iter_next_value (&_tmp6_);
		_tmp5_.pred_id = g_variant_get_int32 (_tmp9_);
		g_variant_unref (_tmp9_);
		_tmp10_ = g_variant_iter_next_value (&_tmp6_);
		_tmp5_.object_id = g_variant_get_int32 (_tmp10_);
		g_variant_unref (_tmp10_);
		_tmp2_[_tmp2__length++] = _tmp5_;
		g_variant_unref (_tmp4_);
	}
	deletes_length1 = _tmp2__length1;
	deletes = _tmp2_;
	g_variant_unref (_tmp1_);
	inserts_length1 = 0;
	_tmp11_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp12_ = g_new (Event, 5);
	_tmp12__length = 0;
	_tmp12__size = 4;
	_tmp12__length1 = 0;
	g_variant_iter_init (&_tmp13_, _tmp11_);
	for (; (_tmp14_ = g_variant_iter_next_value (&_tmp13_)) != NULL; _tmp12__length1++) {
		Event _tmp15_;
		GVariantIter _tmp16_;
		GVariant* _tmp17_;
		GVariant* _tmp18_;
		GVariant* _tmp19_;
		GVariant* _tmp20_;
		if (_tmp12__size == _tmp12__length) {
			_tmp12__size = 2 * _tmp12__size;
			_tmp12_ = g_renew (Event, _tmp12_, _tmp12__size + 1);
		}
		g_variant_iter_init (&_tmp16_, _tmp14_);
		_tmp17_ = g_variant_iter_next_value (&_tmp16_);
		_tmp15_.graph_id = g_variant_get_int32 (_tmp17_);
		g_variant_unref (_tmp17_);
		_tmp18_ = g_variant_iter_next_value (&_tmp16_);
		_tmp15_.subject_id = g_variant_get_int32 (_tmp18_);
		g_variant_unref (_tmp18_);
		_tmp19_ = g_variant_iter_next_value (&_tmp16_);
		_tmp15_.pred_id = g_variant_get_int32 (_tmp19_);
		g_variant_unref (_tmp19_);
		_tmp20_ = g_variant_iter_next_value (&_tmp16_);
		_tmp15_.object_id = g_variant_get_int32 (_tmp20_);
		g_variant_unref (_tmp20_);
		_tmp12_[_tmp12__length++] = _tmp15_;
		g_variant_unref (_tmp14_);
	}
	inserts_length1 = _tmp12__length1;
	inserts = _tmp12_;
	g_variant_unref (_tmp11_);
	g_signal_emit_by_name (self, "graph-updated", class_name, deletes, deletes_length1, inserts, inserts_length1);
	_g_free0 (class_name);
	deletes = (g_free (deletes), NULL);
	inserts = (g_free (inserts), NULL);
}


static void resources_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "GraphUpdated") == 0) {
		_dbus_handle_resources_graph_updated ((Resources*) proxy, parameters);
	}
}


static void resources_proxy_init (ResourcesProxy* self) {
}


static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data) {
	g_simple_async_result_set_op_res_gpointer (user_data, g_object_ref (res), g_object_unref);
	g_simple_async_result_complete (user_data);
	g_object_unref (user_data);
}


static void resources_proxy_sparql_update_async_async (Resources* self, const gchar* query, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	TRACKER_SPARQL_ERROR;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.Tracker1.Resources", "SparqlUpdate");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (query));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void resources_proxy_sparql_update_async_finish (Resources* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void resources_proxy_resources_interface_init (ResourcesIface* iface) {
	iface->sparql_update_async = resources_proxy_sparql_update_async_async;
	iface->sparql_update_finish = resources_proxy_sparql_update_async_finish;
}


static void _dbus_resources_sparql_update_async (Resources* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* query = NULL;
	GVariant* _tmp21_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp21_ = g_variant_iter_next_value (&_arguments_iter);
	query = g_variant_dup_string (_tmp21_, NULL);
	g_variant_unref (_tmp21_);
	resources_sparql_update_async (self, query, (GAsyncReadyCallback) _dbus_resources_sparql_update_async_ready, invocation);
	_g_free0 (query);
}


static void _dbus_resources_sparql_update_async_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	invocation = _user_data_;
	resources_sparql_update_finish ((Resources*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void resources_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "SparqlUpdate") == 0) {
		_dbus_resources_sparql_update_async (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* resources_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean resources_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_resources_graph_updated (GObject* _sender, const gchar* class_name, Event* deletes, int deletes_length1, Event* inserts, int inserts_length1, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	Event* _tmp22_;
	GVariantBuilder _tmp23_;
	int _tmp24_;
	Event* _tmp26_;
	GVariantBuilder _tmp27_;
	int _tmp28_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (class_name));
	_tmp22_ = deletes;
	g_variant_builder_init (&_tmp23_, G_VARIANT_TYPE ("a(iiii)"));
	for (_tmp24_ = 0; _tmp24_ < deletes_length1; _tmp24_++) {
		GVariantBuilder _tmp25_;
		g_variant_builder_init (&_tmp25_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp25_, g_variant_new_int32 ((*_tmp22_).graph_id));
		g_variant_builder_add_value (&_tmp25_, g_variant_new_int32 ((*_tmp22_).subject_id));
		g_variant_builder_add_value (&_tmp25_, g_variant_new_int32 ((*_tmp22_).pred_id));
		g_variant_builder_add_value (&_tmp25_, g_variant_new_int32 ((*_tmp22_).object_id));
		g_variant_builder_add_value (&_tmp23_, g_variant_builder_end (&_tmp25_));
		_tmp22_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp23_));
	_tmp26_ = inserts;
	g_variant_builder_init (&_tmp27_, G_VARIANT_TYPE ("a(iiii)"));
	for (_tmp28_ = 0; _tmp28_ < inserts_length1; _tmp28_++) {
		GVariantBuilder _tmp29_;
		g_variant_builder_init (&_tmp29_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp29_, g_variant_new_int32 ((*_tmp26_).graph_id));
		g_variant_builder_add_value (&_tmp29_, g_variant_new_int32 ((*_tmp26_).subject_id));
		g_variant_builder_add_value (&_tmp29_, g_variant_new_int32 ((*_tmp26_).pred_id));
		g_variant_builder_add_value (&_tmp29_, g_variant_new_int32 ((*_tmp26_).object_id));
		g_variant_builder_add_value (&_tmp27_, g_variant_builder_end (&_tmp29_));
		_tmp26_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp27_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.Tracker1.Resources", "GraphUpdated", _arguments, NULL);
}


guint resources_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_resources_dbus_interface_info), &_resources_dbus_interface_vtable, data, _resources_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "graph-updated", (GCallback) _dbus_resources_graph_updated, data);
	return result;
}


static void _resources_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_resources_graph_updated, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void g_cclosure_user_marshal_VOID__BOXED_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOXED_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOXED_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_if_fail (n_param_values == 3);
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		data1 = closure->data;
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		data2 = param_values->data[0].v_pointer;
#line 650 "test-class-signal-performance.c"
	} else {
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		data1 = param_values->data[0].v_pointer;
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		data2 = closure->data;
#line 656 "test-class-signal-performance.c"
	}
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	callback = (GMarshalFunc_VOID__BOXED_INT) (marshal_data ? marshal_data : cc->callback);
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 662 "test-class-signal-performance.c"
}


static void g_cclosure_user_marshal_VOID__BOXED_INT_BOXED_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOXED_INT_BOXED_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__BOXED_INT_BOXED_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_if_fail (n_param_values == 5);
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		data1 = closure->data;
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		data2 = param_values->data[0].v_pointer;
#line 681 "test-class-signal-performance.c"
	} else {
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		data1 = param_values->data[0].v_pointer;
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		data2 = closure->data;
#line 687 "test-class-signal-performance.c"
	}
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	callback = (GMarshalFunc_VOID__BOXED_INT_BOXED_INT) (marshal_data ? marshal_data : cc->callback);
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_int (param_values + 2), g_value_get_boxed (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 693 "test-class-signal-performance.c"
}


static void resourcesclass_base_init (ResourcesClassIface * iface) {
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	static gboolean initialized = FALSE;
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (!initialized) {
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		initialized = TRUE;
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_signal_new ("subjects_added", TYPE_RESOURCESCLASS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_INT, G_TYPE_NONE, 2, G_TYPE_STRV, G_TYPE_INT);
#line 64 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_signal_new ("subjects_changed", TYPE_RESOURCESCLASS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_INT_BOXED_INT, G_TYPE_NONE, 4, G_TYPE_STRV, G_TYPE_INT, G_TYPE_STRV, G_TYPE_INT);
#line 708 "test-class-signal-performance.c"
	}
}


GType resourcesclass_get_type (void) {
	static volatile gsize resourcesclass_type_id__volatile = 0;
	if (g_once_init_enter (&resourcesclass_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ResourcesClassIface), (GBaseInitFunc) resourcesclass_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType resourcesclass_type_id;
		resourcesclass_type_id = g_type_register_static (G_TYPE_INTERFACE, "ResourcesClass", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (resourcesclass_type_id, G_TYPE_DBUS_PROXY);
		g_type_set_qdata (resourcesclass_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) resourcesclass_proxy_get_type);
		g_type_set_qdata (resourcesclass_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.Tracker1.Resources.Class");
		g_type_set_qdata (resourcesclass_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_resourcesclass_dbus_interface_info));
		g_type_set_qdata (resourcesclass_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) resourcesclass_register_object);
		g_once_init_leave (&resourcesclass_type_id__volatile, resourcesclass_type_id);
	}
	return resourcesclass_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (ResourcesClassProxy, resourcesclass_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_RESOURCESCLASS, resourcesclass_proxy_resourcesclass_interface_init) )
static void resourcesclass_proxy_class_init (ResourcesClassProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = resourcesclass_proxy_g_signal;
}


static void _dbus_handle_resourcesclass_subjects_added (ResourcesClass* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	gchar** subjects = NULL;
	int subjects_length1;
	GVariant* _tmp30_;
	gchar** _tmp31_;
	int _tmp31__length;
	int _tmp31__size;
	int _tmp31__length1;
	GVariantIter _tmp32_;
	GVariant* _tmp33_;
	g_variant_iter_init (&_arguments_iter, parameters);
	subjects_length1 = 0;
	_tmp30_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp31_ = g_new (gchar*, 5);
	_tmp31__length = 0;
	_tmp31__size = 4;
	_tmp31__length1 = 0;
	g_variant_iter_init (&_tmp32_, _tmp30_);
	for (; (_tmp33_ = g_variant_iter_next_value (&_tmp32_)) != NULL; _tmp31__length1++) {
		if (_tmp31__size == _tmp31__length) {
			_tmp31__size = 2 * _tmp31__size;
			_tmp31_ = g_renew (gchar*, _tmp31_, _tmp31__size + 1);
		}
		_tmp31_[_tmp31__length++] = g_variant_dup_string (_tmp33_, NULL);
		g_variant_unref (_tmp33_);
	}
	subjects_length1 = _tmp31__length1;
	_tmp31_[_tmp31__length] = NULL;
	subjects = _tmp31_;
	g_variant_unref (_tmp30_);
	g_signal_emit_by_name (self, "subjects-added", subjects, subjects_length1);
	subjects = (_vala_array_free (subjects, subjects_length1, (GDestroyNotify) g_free), NULL);
}


static void _dbus_handle_resourcesclass_subjects_changed (ResourcesClass* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	gchar** subjects = NULL;
	int subjects_length1;
	GVariant* _tmp34_;
	gchar** _tmp35_;
	int _tmp35__length;
	int _tmp35__size;
	int _tmp35__length1;
	GVariantIter _tmp36_;
	GVariant* _tmp37_;
	gchar** preds = NULL;
	int preds_length1;
	GVariant* _tmp38_;
	gchar** _tmp39_;
	int _tmp39__length;
	int _tmp39__size;
	int _tmp39__length1;
	GVariantIter _tmp40_;
	GVariant* _tmp41_;
	g_variant_iter_init (&_arguments_iter, parameters);
	subjects_length1 = 0;
	_tmp34_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp35_ = g_new (gchar*, 5);
	_tmp35__length = 0;
	_tmp35__size = 4;
	_tmp35__length1 = 0;
	g_variant_iter_init (&_tmp36_, _tmp34_);
	for (; (_tmp37_ = g_variant_iter_next_value (&_tmp36_)) != NULL; _tmp35__length1++) {
		if (_tmp35__size == _tmp35__length) {
			_tmp35__size = 2 * _tmp35__size;
			_tmp35_ = g_renew (gchar*, _tmp35_, _tmp35__size + 1);
		}
		_tmp35_[_tmp35__length++] = g_variant_dup_string (_tmp37_, NULL);
		g_variant_unref (_tmp37_);
	}
	subjects_length1 = _tmp35__length1;
	_tmp35_[_tmp35__length] = NULL;
	subjects = _tmp35_;
	g_variant_unref (_tmp34_);
	preds_length1 = 0;
	_tmp38_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp39_ = g_new (gchar*, 5);
	_tmp39__length = 0;
	_tmp39__size = 4;
	_tmp39__length1 = 0;
	g_variant_iter_init (&_tmp40_, _tmp38_);
	for (; (_tmp41_ = g_variant_iter_next_value (&_tmp40_)) != NULL; _tmp39__length1++) {
		if (_tmp39__size == _tmp39__length) {
			_tmp39__size = 2 * _tmp39__size;
			_tmp39_ = g_renew (gchar*, _tmp39_, _tmp39__size + 1);
		}
		_tmp39_[_tmp39__length++] = g_variant_dup_string (_tmp41_, NULL);
		g_variant_unref (_tmp41_);
	}
	preds_length1 = _tmp39__length1;
	_tmp39_[_tmp39__length] = NULL;
	preds = _tmp39_;
	g_variant_unref (_tmp38_);
	g_signal_emit_by_name (self, "subjects-changed", subjects, subjects_length1, preds, preds_length1);
	subjects = (_vala_array_free (subjects, subjects_length1, (GDestroyNotify) g_free), NULL);
	preds = (_vala_array_free (preds, preds_length1, (GDestroyNotify) g_free), NULL);
}


static void resourcesclass_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "SubjectsAdded") == 0) {
		_dbus_handle_resourcesclass_subjects_added ((ResourcesClass*) proxy, parameters);
	} else if (strcmp (signal_name, "SubjectsChanged") == 0) {
		_dbus_handle_resourcesclass_subjects_changed ((ResourcesClass*) proxy, parameters);
	}
}


static void resourcesclass_proxy_init (ResourcesClassProxy* self) {
}


static void resourcesclass_proxy_resourcesclass_interface_init (ResourcesClassIface* iface) {
}


static void resourcesclass_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}


static GVariant* resourcesclass_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean resourcesclass_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_resourcesclass_subjects_added (GObject* _sender, gchar** subjects, int subjects_length1, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp42_;
	GVariantBuilder _tmp43_;
	int _tmp44_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_tmp42_ = subjects;
	g_variant_builder_init (&_tmp43_, G_VARIANT_TYPE ("as"));
	for (_tmp44_ = 0; _tmp44_ < subjects_length1; _tmp44_++) {
		g_variant_builder_add_value (&_tmp43_, g_variant_new_string (*_tmp42_));
		_tmp42_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp43_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.Tracker1.Resources.Class", "SubjectsAdded", _arguments, NULL);
}


static void _dbus_resourcesclass_subjects_changed (GObject* _sender, gchar** subjects, int subjects_length1, gchar** preds, int preds_length1, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp45_;
	GVariantBuilder _tmp46_;
	int _tmp47_;
	gchar** _tmp48_;
	GVariantBuilder _tmp49_;
	int _tmp50_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_tmp45_ = subjects;
	g_variant_builder_init (&_tmp46_, G_VARIANT_TYPE ("as"));
	for (_tmp47_ = 0; _tmp47_ < subjects_length1; _tmp47_++) {
		g_variant_builder_add_value (&_tmp46_, g_variant_new_string (*_tmp45_));
		_tmp45_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp46_));
	_tmp48_ = preds;
	g_variant_builder_init (&_tmp49_, G_VARIANT_TYPE ("as"));
	for (_tmp50_ = 0; _tmp50_ < preds_length1; _tmp50_++) {
		g_variant_builder_add_value (&_tmp49_, g_variant_new_string (*_tmp48_));
		_tmp48_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp49_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.Tracker1.Resources.Class", "SubjectsChanged", _arguments, NULL);
}


guint resourcesclass_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_resourcesclass_dbus_interface_info), &_resourcesclass_dbus_interface_vtable, data, _resourcesclass_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "subjects-added", (GCallback) _dbus_resourcesclass_subjects_added, data);
	g_signal_connect (object, "subjects-changed", (GCallback) _dbus_resourcesclass_subjects_changed, data);
	return result;
}


static void _resourcesclass_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_resourcesclass_subjects_added, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_resourcesclass_subjects_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _test_app_on_subjects_added_resourcesclass_subjects_added (ResourcesClass* _sender, gchar** subjects, int subjects_length1, gpointer self) {
#line 95 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	test_app_on_subjects_added ((TestApp*) self, subjects, subjects_length1);
#line 969 "test-class-signal-performance.c"
}


static void _test_app_on_subjects_changed_resourcesclass_subjects_changed (ResourcesClass* _sender, gchar** subjects, int subjects_length1, gchar** preds, int preds_length1, gpointer self) {
#line 96 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	test_app_on_subjects_changed ((TestApp*) self, subjects, subjects_length1, preds, preds_length1);
#line 976 "test-class-signal-performance.c"
}


static void _test_app_on_graph_updated_received_resources_graph_updated (Resources* _sender, const gchar* class_name, Event* deletes, int deletes_length1, Event* inserts, int inserts_length1, gpointer self) {
#line 98 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	test_app_on_graph_updated_received ((TestApp*) self, class_name, deletes, deletes_length1, inserts, inserts_length1);
#line 983 "test-class-signal-performance.c"
}


TestApp* test_app_construct (GType object_type) {
	TestApp* self = NULL;
	gboolean _tmp0_ = FALSE;
	GError * _inner_error_ = NULL;
#line 80 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	self = (TestApp*) g_type_create_instance (object_type);
#line 80 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp0_ = self->priv->initialized;
#line 80 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_vala_return_val_if_fail (!_tmp0_, "!initialized", NULL);
#line 997 "test-class-signal-performance.c"
	{
		TrackerSparqlConnection* _tmp1_ = NULL;
		TrackerSparqlConnection* _tmp2_ = NULL;
		TrackerSparqlConnection* _tmp3_ = NULL;
		Resources* _tmp4_ = NULL;
		Resources* _tmp5_ = NULL;
		Resources* _tmp6_ = NULL;
		ResourcesClass* _tmp7_ = NULL;
		ResourcesClass* _tmp8_ = NULL;
		ResourcesClass* _tmp9_ = NULL;
		ResourcesClass* _tmp10_ = NULL;
		ResourcesClass* _tmp11_ = NULL;
		Resources* _tmp12_ = NULL;
		GTimer* _tmp13_ = NULL;
#line 83 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp2_ = tracker_sparql_connection_get (NULL, &_inner_error_);
#line 83 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp1_ = _tmp2_;
#line 83 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1018 "test-class-signal-performance.c"
			goto __catch0_g_error;
		}
#line 83 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp3_ = _tmp1_;
#line 83 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp1_ = NULL;
#line 83 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_g_object_unref0 (self->priv->con);
#line 83 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		self->priv->con = _tmp3_;
#line 85 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp5_ = g_initable_new (TYPE_RESOURCES_PROXY, NULL, &_inner_error_, "g-flags", G_DBUS_PROXY_FLAGS_DO_NOT_LOAD_PROPERTIES | G_DBUS_PROXY_FLAGS_DO_NOT_CONNECT_SIGNALS, "g-name", "org.freedesktop.Tracker1", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/freedesktop/Tracker1/Resources", "g-interface-name", "org.freedesktop.Tracker1.Resources", "g-interface-info", g_type_get_qdata (TYPE_RESOURCES, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
#line 85 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp4_ = (Resources*) _tmp5_;
#line 85 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 85 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			_g_object_unref0 (_tmp1_);
#line 1037 "test-class-signal-performance.c"
			goto __catch0_g_error;
		}
#line 85 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp6_ = _tmp4_;
#line 85 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp4_ = NULL;
#line 85 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_g_object_unref0 (test_app_resources_object);
#line 85 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		test_app_resources_object = _tmp6_;
#line 90 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp8_ = g_initable_new (TYPE_RESOURCESCLASS_PROXY, NULL, &_inner_error_, "g-flags", G_DBUS_PROXY_FLAGS_DO_NOT_LOAD_PROPERTIES | G_DBUS_PROXY_FLAGS_DO_NOT_CONNECT_SIGNALS, "g-name", "org.freedesktop.Tracker1", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/freedesktop/Tracker1/Resources/Classes/nmm/MusicPiece", "g-interface-name", "org.freedesktop.Tracker1.Resources.Class", "g-interface-info", g_type_get_qdata (TYPE_RESOURCESCLASS, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
#line 90 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp7_ = (ResourcesClass*) _tmp8_;
#line 90 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 90 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			_g_object_unref0 (_tmp4_);
#line 90 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			_g_object_unref0 (_tmp1_);
#line 1058 "test-class-signal-performance.c"
			goto __catch0_g_error;
		}
#line 90 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp9_ = _tmp7_;
#line 90 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp7_ = NULL;
#line 90 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_g_object_unref0 (test_app_class_object);
#line 90 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		test_app_class_object = _tmp9_;
#line 95 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp10_ = test_app_class_object;
#line 95 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_signal_connect (_tmp10_, "subjects-added", (GCallback) _test_app_on_subjects_added_resourcesclass_subjects_added, self);
#line 96 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp11_ = test_app_class_object;
#line 96 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_signal_connect (_tmp11_, "subjects-changed", (GCallback) _test_app_on_subjects_changed_resourcesclass_subjects_changed, self);
#line 98 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp12_ = test_app_resources_object;
#line 98 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_signal_connect (_tmp12_, "graph-updated", (GCallback) _test_app_on_graph_updated_received_resources_graph_updated, self);
#line 99 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp13_ = g_timer_new ();
#line 99 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_g_timer_destroy0 (self->priv->t);
#line 99 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		self->priv->t = _tmp13_;
#line 82 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_g_object_unref0 (_tmp7_);
#line 82 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_g_object_unref0 (_tmp4_);
#line 82 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_g_object_unref0 (_tmp1_);
#line 1093 "test-class-signal-performance.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
#line 82 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		e = _inner_error_;
#line 82 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_inner_error_ = NULL;
#line 102 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp14_ = e;
#line 102 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp15_ = _tmp14_->message;
#line 102 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_warning ("test-class-signal-performance.vala:102: Could not connect to D-Bus ser" \
"vice: %s", _tmp15_);
#line 103 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		self->priv->initialized = FALSE;
#line 104 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_g_error_free0 (e);
#line 104 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		return self;
#line 1117 "test-class-signal-performance.c"
	}
	__finally0:
#line 82 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 82 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 82 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_clear_error (&_inner_error_);
#line 82 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		return NULL;
#line 1128 "test-class-signal-performance.c"
	}
#line 106 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	self->priv->initialized = TRUE;
#line 80 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return self;
#line 1134 "test-class-signal-performance.c"
}


TestApp* test_app_new (void) {
#line 80 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return test_app_construct (TYPE_TEST_APP);
#line 1141 "test-class-signal-performance.c"
}


static void test_app_on_subjects_changed (TestApp* self, gchar** subjects, int subjects_length1, gchar** preds, int preds_length1) {
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp3_ = 0;
	GTimer* _tmp4_ = NULL;
	gdouble _tmp5_ = 0.0;
#line 109 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_if_fail (self != NULL);
#line 110 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp0_ = subjects;
#line 110 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp0__length1 = subjects_length1;
#line 1157 "test-class-signal-performance.c"
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
#line 110 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		s_collection = _tmp0_;
#line 110 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		s_collection_length1 = _tmp0__length1;
#line 110 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		for (s_it = 0; s_it < _tmp0__length1; s_it = s_it + 1) {
#line 1169 "test-class-signal-performance.c"
			gchar* _tmp1_ = NULL;
			gchar* s = NULL;
#line 110 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			_tmp1_ = g_strdup (s_collection[s_it]);
#line 110 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			s = _tmp1_;
#line 1176 "test-class-signal-performance.c"
			{
				gint _tmp2_ = 0;
#line 111 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
				_tmp2_ = self->priv->count;
#line 111 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
				self->priv->count = _tmp2_ + 1;
#line 110 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
				_g_free0 (s);
#line 1185 "test-class-signal-performance.c"
			}
		}
	}
#line 114 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp3_ = self->priv->count;
#line 114 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp4_ = self->priv->t;
#line 114 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp5_ = g_timer_elapsed (_tmp4_, NULL);
#line 114 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_print ("Old class signal count=%d time=%lf\n", _tmp3_, _tmp5_);
#line 1197 "test-class-signal-performance.c"
}


static void test_app_on_subjects_added (TestApp* self, gchar** subjects, int subjects_length1) {
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp3_ = 0;
	GTimer* _tmp4_ = NULL;
	gdouble _tmp5_ = 0.0;
#line 117 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_if_fail (self != NULL);
#line 118 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp0_ = subjects;
#line 118 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp0__length1 = subjects_length1;
#line 1213 "test-class-signal-performance.c"
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
#line 118 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		s_collection = _tmp0_;
#line 118 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		s_collection_length1 = _tmp0__length1;
#line 118 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		for (s_it = 0; s_it < _tmp0__length1; s_it = s_it + 1) {
#line 1225 "test-class-signal-performance.c"
			gchar* _tmp1_ = NULL;
			gchar* s = NULL;
#line 118 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			_tmp1_ = g_strdup (s_collection[s_it]);
#line 118 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			s = _tmp1_;
#line 1232 "test-class-signal-performance.c"
			{
				gint _tmp2_ = 0;
#line 119 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
				_tmp2_ = self->priv->count;
#line 119 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
				self->priv->count = _tmp2_ + 1;
#line 118 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
				_g_free0 (s);
#line 1241 "test-class-signal-performance.c"
			}
		}
	}
#line 122 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp3_ = self->priv->count;
#line 122 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp4_ = self->priv->t;
#line 122 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp5_ = g_timer_elapsed (_tmp4_, NULL);
#line 122 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_print ("Old class signal count=%d time=%lf\n", _tmp3_, _tmp5_);
#line 1253 "test-class-signal-performance.c"
}


static void test_app_on_graph_updated_received (TestApp* self, const gchar* class_name, Event* deletes, int deletes_length1, Event* inserts, int inserts_length1) {
	Event* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp2_ = 0;
	GTimer* _tmp3_ = NULL;
	gdouble _tmp4_ = 0.0;
#line 125 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_if_fail (self != NULL);
#line 125 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_if_fail (class_name != NULL);
#line 126 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp0_ = inserts;
#line 126 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp0__length1 = inserts_length1;
#line 1271 "test-class-signal-performance.c"
	{
		Event* insert_collection = NULL;
		gint insert_collection_length1 = 0;
		gint _insert_collection_size_ = 0;
		gint insert_it = 0;
#line 126 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		insert_collection = _tmp0_;
#line 126 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		insert_collection_length1 = _tmp0__length1;
#line 126 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		for (insert_it = 0; insert_it < _tmp0__length1; insert_it = insert_it + 1) {
#line 1283 "test-class-signal-performance.c"
			Event insert = {0};
#line 126 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			insert = insert_collection[insert_it];
#line 1287 "test-class-signal-performance.c"
			{
				gint _tmp1_ = 0;
#line 127 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
				_tmp1_ = self->priv->count;
#line 127 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
				self->priv->count = _tmp1_ + 1;
#line 1294 "test-class-signal-performance.c"
			}
		}
	}
#line 129 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp2_ = self->priv->count;
#line 129 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp3_ = self->priv->t;
#line 129 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp4_ = g_timer_elapsed (_tmp3_, NULL);
#line 129 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_print ("New class signal count=%d time=%lf\n", _tmp2_, _tmp4_);
#line 1306 "test-class-signal-performance.c"
}


static void test_app_insert_data (TestApp* self) {
	gint i = 0;
	GTimer* _tmp0_ = NULL;
#line 132 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_if_fail (self != NULL);
#line 135 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp0_ = self->priv->t;
#line 135 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_timer_start (_tmp0_);
#line 1319 "test-class-signal-performance.c"
	{
		gboolean _tmp1_ = FALSE;
#line 136 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		i = 0;
#line 136 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		_tmp1_ = TRUE;
#line 136 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		while (TRUE) {
#line 1328 "test-class-signal-performance.c"
			gint _tmp3_ = 0;
			gchar* upqry = NULL;
			gint _tmp4_ = 0;
			gint _tmp5_ = 0;
			gchar* _tmp6_ = NULL;
			Resources* _tmp7_ = NULL;
			const gchar* _tmp8_ = NULL;
#line 136 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			if (!_tmp1_) {
#line 1338 "test-class-signal-performance.c"
				gint _tmp2_ = 0;
#line 136 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
				_tmp2_ = i;
#line 136 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
				i = _tmp2_ + 1;
#line 1344 "test-class-signal-performance.c"
			}
#line 136 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			_tmp1_ = FALSE;
#line 136 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			_tmp3_ = i;
#line 136 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			if (!(_tmp3_ <= max_signals)) {
#line 136 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
				break;
#line 1354 "test-class-signal-performance.c"
			}
#line 137 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			_tmp4_ = i;
#line 137 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			_tmp5_ = i;
#line 137 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			_tmp6_ = g_strdup_printf ("INSERT { <%d> a nmm:MusicPiece ; nie:title '%s %d' }", _tmp4_, title_data, _tmp5_);
#line 137 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			upqry = _tmp6_;
#line 138 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			_tmp7_ = test_app_resources_object;
#line 138 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			_tmp8_ = upqry;
#line 138 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			resources_sparql_update_async (_tmp7_, _tmp8_, NULL, NULL);
#line 136 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			_g_free0 (upqry);
#line 1372 "test-class-signal-performance.c"
		}
	}
}


static gboolean test_app_in_mainloop (TestApp* self) {
	gboolean result = FALSE;
#line 142 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 143 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	test_app_insert_data (self);
#line 144 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	result = FALSE;
#line 144 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return result;
#line 1388 "test-class-signal-performance.c"
}


static gboolean _test_app_in_mainloop_gsource_func (gpointer self) {
	gboolean result;
	result = test_app_in_mainloop ((TestApp*) self);
#line 149 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return result;
#line 1397 "test-class-signal-performance.c"
}


gint test_app_run (TestApp* self) {
	gint result = 0;
	GMainLoop* _tmp0_ = NULL;
	GMainLoop* _tmp1_ = NULL;
#line 147 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 148 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp0_ = g_main_loop_new (NULL, FALSE);
#line 148 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_g_main_loop_unref0 (self->priv->loop);
#line 148 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	self->priv->loop = _tmp0_;
#line 149 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _test_app_in_mainloop_gsource_func, test_app_ref (self), test_app_unref);
#line 150 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp1_ = self->priv->loop;
#line 150 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_main_loop_run (_tmp1_);
#line 151 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	result = 0;
#line 151 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return result;
#line 1423 "test-class-signal-performance.c"
}


static void value_test_app_init (GValue* value) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	value->data[0].v_pointer = NULL;
#line 1430 "test-class-signal-performance.c"
}


static void value_test_app_free_value (GValue* value) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (value->data[0].v_pointer) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		test_app_unref (value->data[0].v_pointer);
#line 1439 "test-class-signal-performance.c"
	}
}


static void value_test_app_copy_value (const GValue* src_value, GValue* dest_value) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (src_value->data[0].v_pointer) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		dest_value->data[0].v_pointer = test_app_ref (src_value->data[0].v_pointer);
#line 1449 "test-class-signal-performance.c"
	} else {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1453 "test-class-signal-performance.c"
	}
}


static gpointer value_test_app_peek_pointer (const GValue* value) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return value->data[0].v_pointer;
#line 1461 "test-class-signal-performance.c"
}


static gchar* value_test_app_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (collect_values[0].v_pointer) {
#line 1468 "test-class-signal-performance.c"
		TestApp* object;
		object = collect_values[0].v_pointer;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		if (object->parent_instance.g_class == NULL) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1475 "test-class-signal-performance.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1479 "test-class-signal-performance.c"
		}
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		value->data[0].v_pointer = test_app_ref (object);
#line 1483 "test-class-signal-performance.c"
	} else {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		value->data[0].v_pointer = NULL;
#line 1487 "test-class-signal-performance.c"
	}
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return NULL;
#line 1491 "test-class-signal-performance.c"
}


static gchar* value_test_app_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	TestApp** object_p;
	object_p = collect_values[0].v_pointer;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (!object_p) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1502 "test-class-signal-performance.c"
	}
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (!value->data[0].v_pointer) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		*object_p = NULL;
#line 1508 "test-class-signal-performance.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		*object_p = value->data[0].v_pointer;
#line 1512 "test-class-signal-performance.c"
	} else {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		*object_p = test_app_ref (value->data[0].v_pointer);
#line 1516 "test-class-signal-performance.c"
	}
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return NULL;
#line 1520 "test-class-signal-performance.c"
}


GParamSpec* param_spec_test_app (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecTestApp* spec;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TEST_APP), NULL);
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return G_PARAM_SPEC (spec);
#line 1534 "test-class-signal-performance.c"
}


gpointer value_get_test_app (const GValue* value) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEST_APP), NULL);
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return value->data[0].v_pointer;
#line 1543 "test-class-signal-performance.c"
}


void value_set_test_app (GValue* value, gpointer v_object) {
	TestApp* old;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEST_APP));
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	old = value->data[0].v_pointer;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (v_object) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEST_APP));
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		value->data[0].v_pointer = v_object;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		test_app_ref (value->data[0].v_pointer);
#line 1563 "test-class-signal-performance.c"
	} else {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		value->data[0].v_pointer = NULL;
#line 1567 "test-class-signal-performance.c"
	}
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (old) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		test_app_unref (old);
#line 1573 "test-class-signal-performance.c"
	}
}


void value_take_test_app (GValue* value, gpointer v_object) {
	TestApp* old;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEST_APP));
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	old = value->data[0].v_pointer;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (v_object) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEST_APP));
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		value->data[0].v_pointer = v_object;
#line 1592 "test-class-signal-performance.c"
	} else {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		value->data[0].v_pointer = NULL;
#line 1596 "test-class-signal-performance.c"
	}
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (old) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		test_app_unref (old);
#line 1602 "test-class-signal-performance.c"
	}
}


static void test_app_class_init (TestAppClass * klass) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	test_app_parent_class = g_type_class_peek_parent (klass);
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	((TestAppClass *) klass)->finalize = test_app_finalize;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_type_class_add_private (klass, sizeof (TestAppPrivate));
#line 1614 "test-class-signal-performance.c"
}


static void test_app_instance_init (TestApp * self) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	self->priv = TEST_APP_GET_PRIVATE (self);
#line 75 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	self->priv->initialized = FALSE;
#line 77 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	self->priv->count = 0;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	self->ref_count = 1;
#line 1627 "test-class-signal-performance.c"
}


static void test_app_finalize (TestApp* obj) {
	TestApp * self;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TEST_APP, TestApp);
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_signal_handlers_destroy (self);
#line 74 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_g_main_loop_unref0 (self->priv->loop);
#line 76 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_g_object_unref0 (self->priv->con);
#line 78 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_g_timer_destroy0 (self->priv->t);
#line 1643 "test-class-signal-performance.c"
}


GType test_app_get_type (void) {
	static volatile gsize test_app_type_id__volatile = 0;
	if (g_once_init_enter (&test_app_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_test_app_init, value_test_app_free_value, value_test_app_copy_value, value_test_app_peek_pointer, "p", value_test_app_collect_value, "p", value_test_app_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (TestAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) test_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TestApp), 0, (GInstanceInitFunc) test_app_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType test_app_type_id;
		test_app_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TestApp", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&test_app_type_id__volatile, test_app_type_id);
	}
	return test_app_type_id__volatile;
}


gpointer test_app_ref (gpointer instance) {
	TestApp* self;
	self = instance;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	g_atomic_int_inc (&self->ref_count);
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return instance;
#line 1668 "test-class-signal-performance.c"
}


void test_app_unref (gpointer instance) {
	TestApp* self;
	self = instance;
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		TEST_APP_GET_CLASS (self)->finalize (self);
#line 71 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1681 "test-class-signal-performance.c"
	}
}


gint _vala_main (gchar** args, int args_length1) {
	gint result = 0;
	TestApp* app = NULL;
	TestApp* _tmp0_ = NULL;
	gint _tmp1_ = 0;
#line 156 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp0_ = test_app_new ();
#line 156 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	app = _tmp0_;
#line 158 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_tmp1_ = test_app_run (app);
#line 158 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	result = _tmp1_;
#line 158 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	_test_app_unref0 (app);
#line 158 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return result;
#line 1703 "test-class-signal-performance.c"
}


int main (int argc, char ** argv) {
#if !GLIB_CHECK_VERSION (2,35,0)
	g_type_init ();
#endif
#line 155 "/home/carlos/Source/gnome/tracker/tests/functional-tests/ipc/test-class-signal-performance.vala"
	return _vala_main (argv, argc);
#line 1713 "test-class-signal-performance.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



